package org.autochthonous.graphics.rt;

public class AtmosphereDataIterator
{
    private static AtmosphereDataIterator dataList = null;

    private boolean             disposed = false;
    private AtmosphereDataIterator   next = null;

    AtmosphereData data;

    private AtmosphereDataIterator()
    {
    }
    
    public static AtmosphereDataIterator getInstance(
        AtmosphereData   data)
    {
        AtmosphereDataIterator   d;

        if (dataList == null)
        {
            d = new AtmosphereDataIterator();
        }
        else
        {
            d = dataList;
            dataList = dataList.next;
        }

        d.data = data;
        d.disposed = false;

        return d;
    }

    public void dispose()
    {
        if (this.disposed)
        {
            throw new IllegalStateException("attempt to free AtmosphereDataIterator already freed");
        }

        this.disposed = true;
        this.next = dataList;
        dataList = this;
    }

    public boolean hasNext()
    {
        return (data != null);
    }
    
    public AtmosphereData next()
    {
        AtmosphereData  ld = data;
    
        data = data.next;
    
        return ld;
    }
}
