package org.autochthonous.graphics.rt;

import org.autochthonous.graphics.rt.util.*;

/**
 * Class for a viewer - viewers are objects such as cameras that act as 
 * sources for primary rays.
 */
public abstract class Viewer
{
    protected RandomTable     rand = new RandomTable();

    protected String          name = "default";

    protected float           viewFactor = 1;

    public Viewer()
    {
    }

    public String getName()
    {
        return name;
    }

    public float viewFactor()
    {
        return viewFactor;
    }

    public abstract void configureLenseMask(int samples, boolean jitter);

    public abstract Ray generateRay(int sampleNo, float time, float x, float y);
}
